#include <stdio.h>
#include <math.h>

/*-------------------------------------------------------------------*/

void rescale (glob, sizex, sizey, scale_factor)
float  		glob [];
unsigned int	sizex, sizey;
float		scale_factor;
{
long		i;

/* renormalize */
for (i=0; i<sizex*sizey; i++) {
   glob [i] *= scale_factor ;
   glob [i] -= (int) glob[i];
   }
}

/*-------------------------------------------------------------------*/

void takelog (glob, sizex, sizey, scale_factor)
float  		glob [];
unsigned int	sizex, sizey;
float		scale_factor;
{
long		i;
float		ska;

ska = exp (scale_factor) - 1.0;
/* renormalize */
for (i=0; i<sizex*sizey; i++) {
   glob [i] = (float) log ((double) (ska * glob[i] + 1.0)) / scale_factor;
   }
}

/*-------------------------------------------------------------------*/

#define PIX_WID 600
#define PIX_HIG 600
extern FILE *Fopen();
extern FILE *Fopenr();

void main (argc, argv) 
int argc;
char *argv[];

{
static float	data_a [PIX_WID*2];		/* my data array */
static float	data_b [PIX_WID*2];		/* my data array */
unsigned int	data_width, data_height;/* data array dimensions */
int		i, j;
char 		str[80];
FILE		*fp_a, *fp_b, *fp_out;
float 		scale_fact;

if ( argc < 4) {
   printf ("usage: sum <input file> <input file> <output file>\n");
   return;
   }

/*----------------------------------------------------*/
/* open input file */
if ( (fp_a = Fopenr (argv[1], ".flo")) == NULL) {
   printf (" Can't open input file \n");
   return;
   }
if ( NULL == fgets (str, 80, fp_a)) {
   printf (" Can't read input file \n");
   fclose (fp_a);
   return;
   }

sscanf (str, "%d %d", &data_width, &data_height);
printf (" input file a has width %d height %d \n", data_width, data_height);

/*----------------------------------------------------*/
/* open input file */
if ( (fp_b = Fopenr (argv[2], ".flo")) == NULL) {
   printf (" Can't open input file \n");
   return;
   }
if ( NULL == fgets (str, 80, fp_b)) {
   printf (" Can't read input file \n");
   fclose (fp_b);
   return;
   }

sscanf (str, "%d %d", &data_width, &data_height);
printf (" input file b has width %d height %d \n", data_width, data_height);

/*----------------------------------------------------*/
/* open output file */
if ( (fp_out = Fopen (argv[3], ".flo")) == NULL) {
   printf (" Can't open output file \n");
   return;
   }

/* dump the size to output */
fprintf (fp_out, "%d %d\n", data_width, data_height);

/* scale_fact = (float) atof (argv[3]);
printf(" Begin rescaling with scale factor = %f \n", (double) scale_fact); */

for (i=0; i<data_height; i++) {
    printf (" working on row %d\n", i);

    /* read floating point data */
    fread(data_a, sizeof(float), data_width, fp_a);
    fread(data_b, sizeof(float), data_width, fp_b);

    /* (void) rescale (data, data_width, 1, scale_fact); */
    /* (void) takelog (data, data_width, 1, scale_fact); */
    for (j=0; j<data_width; j++) {
         if (data_b [j] > 0.95) data_a[j] = 0.99999;
         /* data_a [j] +=  data_b [j];
         data_a [j] -= (int) data_a [j]; */
         }

    /* dump the floating point data */
    fwrite (data_a, sizeof(float), data_width, fp_out);
    }

fclose (fp_a);
fclose (fp_b);
fclose (fp_out);

}
